// Link Display
// Jeffrey J Weimer
// SVN History: $Revision: 682 $ on $Date: 2008-04-10 10:24:16 -0500 (Thu, 10 Apr 2008) $

#pragma rtGlobals=1
#pragma IgorVersion=6.03
#pragma version = 0.11

//#pragma IndependentModule=LinkDisplay

Static StrConstant kLinkStart ="<link>"
Static StrConstant kLinkEnd = "</link>"
Static StrConstant kregEx = "<link>(.+)</link>"

// Link
// xwave: independent wave
// ywaveList: string list of dependent waves in current folder or via path

Function Link(xwave,ywaveList,[full])
	wave xwave
	string ywaveList
	variable full
	
	string theOne, itsNote, itsLink, xdf
	variable ic, nt
		
	if (!WaveExists(xwave))
		DoAlert 0, "No independent wave for linking!"
		return -1
	endif
	
	if (ParamIsDefault(full))
		full = 0
	endif
	
	if (cmpstr(GetDataFolder(1),GetWavesDataFolder(xwave,1))!=0)
		full = 1
	endif
	
	if (full)
		itsLink = GetWavesDataFolder(xwave,2)
	else
		itsLink = NameofWave(xwave)
	endif
	
	nt = ItemsInList(ywaveList)
	for (ic=0;ic<nt;ic+=1)
		theOne = StringFromList(ic,ywaveList)
		wave ywave = $theOne
		itsNote = note(ywave)
		SplitString/E=(kregEx) itsNote
		if (strlen(S_value)!=0)
			sprintf theOne, "%s%s%s", kLinkStart,itsLink,kLinkEnd
			itsNote = ReplaceString(S_value,itsNote,theOne)
		else
			sprintf itsNote, "%s%s%s\r%s", kLinkStart,itsLink,kLinkEnd,itsNote
		endif
		Note/K ywave, itsNote
	endfor
	return 0
end

// LDisplay
// ywaveList: string list of dependent waves in current folder or via path
// flags: string of flags to append to Display command
// title: string title for graph

Function LDisplay(ywaveList,[flags,title])
	string ywaveList, flags, title
	
	string theOne, itsNote, theXwave, theCmd
	variable ic, nt, na
	
	nt = ItemsInList(ywaveList)

	if (ParamIsDefault(flags))
		flags = ""
	endif
	
	for (ic=0;ic<nt;ic+=1)
		theOne = StringFromList(ic,ywaveList)
		itsNote = note($theOne)
		SplitString/E=(kregEx) itsNote, theXWave
		if (strlen(S_Value)!=0)
			if (ParamIsDefault(title))
				sprintf theCmd "Display%s %s vs %s", flags, theOne, theXwave
			else
				sprintf theCmd "Display%s %s vs %s as \"%s\"", flags, theOne, theXwave, title
			endif
			Execute/Q/Z theCmd
		else
			Display $theOne
		endif
	endfor
	return 0
end

// LAppendToGraph
// ywaveList: string list of dependent waves in current folder or via path

Function LAppendToGraph(ywaveList)
	string ywaveList

	string theOne, itsNote, theXwave
	variable nt, ic

	nt = ItemsInList(ywaveList)
	for (ic=0;ic<nt;ic+=1)
		theOne = StringFromList(ic,ywaveList)
		itsNote = note($theOne)
		SplitString/E=(kregEx) itsNote, theXwave
		if (strlen(S_Value)!=0)
			appendtograph $theOne vs $theXwave
		else
			appendtograph $theOne
		endif
	endfor
	return 0
	
end